#ifndef GTK_HENTRY_SCALE_STATE_H
#define GTK_HENTRY_SCALE_STATE_H

#include "Gtk_HEntryScale.h"

class Gtk_HEntryScale_State : public ::State {

public:
    const char * label;     
    double minval;
    double maxval;
    double val;
    double res;
    double small_step;
    class Gtk_HEntryScale * entry;

    bool log;

    Gtk_HEntryScale_State();        
    void save(FILE * fp);
    void load(FILE * fp);
    void alloc();
    float value();
    float gui_value();
    void apply();
    void grab();
    bool changed();     
};


#endif
