#ifndef FRACT_PARAMS_STATE_H
#define FRACT_PARAMS_STATE_H

#include "Gtk_CoordBox_state.h"
#include "Gtk_HEntryScale_state.h"
#include "fract_params.h"

class Fract_Params_State : public ::State {

 public:

    class Fract_Params * gui;
    class fractal * fract;

				// tree stuffs
    class Gtk_CoordBox_State tree_center;
    class Gtk_CoordBox_State tree_span;
    Gtk_HEntryScale_State init_tree_depth;
    Gtk_HEntryScale_State tree_bisect_iterations;
    Gtk_HEntryScale_State tree_apply_weight;
    Gtk_HEntryScale_State tree_max_depth;
    Gtk_HEntryScale_State tree_ignore_depth;
    Gtk_HEntryScale_State maxiter;
    class Gtk_CoordBox_State zoom;
    class Gtk_CoordBox_State pan;

    bool use_c_from_const_box;

    Gtk_HEntryScale_State w_fix;
    //	expr_ref expr;
    const char * expr_string;
    const char * init_expr_string;
    expr_ref expr_list;
    expr_ref expr_tree;

    char * const_s, * const_a, * const_b, * const_c;
	
    bool bounding_box_visible;
    bool zoom_box_visible;
    bool q_is_c_initially;
    double initial_q_val[4];
    Gtk_HEntryScale_State bounding_res;

    void toggle_using_c_from_const_box();

    void load(FILE * fp);
    void save(FILE * fp);
    Fract_Params * show_dialog();
	    
    void set_expr(FILE *);	/* probably broken */
    void set_expr(const char *, const char *);
	
    void set_default();

    void grab();
    void apply();
    bool changed();

    Fract_Params_State();
};

#endif
