#include "fract_rot.h"
#include "fractal.h"
#include "defs.h"

Fract_Rot::Fract_Rot(Fract_Rot_State * _state) {

	vbox = new Gtk_VBox(False,0);
	perspective = new Gtk_CheckButton("not useful?");
	hbox = new Gtk_HBox(False,0);
	zoom_adj = new Gtk_Adjustment(1, 0, 10, 0.1, 0.1, 0.1);
	zoom = new Gtk_VScale(*zoom_adj);
	rot = new Positioner(100,100);

//        rot.set_usize(100,100);
    
        state = _state;
        state->view = this;

        zoom_val = 1;

	hbox->add(rot);
	hbox->add(zoom);
	vbox->add(hbox);
	vbox->add(perspective);
	gtk_widget_set_events(GTK_WIDGET(rot->gtkobj()),
			      GDK_BUTTON_PRESS_MASK | 
			      GDK_BUTTON_RELEASE_MASK |
			      GDK_EXPOSURE_MASK | 
			      GDK_BUTTON_MOTION_MASK |
			      GDK_POINTER_MOTION_HINT_MASK);
	rot->show();
	zoom->show();
	perspective->show();
	vbox->show();
	hbox->show();
	add(vbox);

	state->rot.pos = rot;

	if(state->fract) {
	    printf("fract is %p is rot\n", state->fract);
	    attach_signals(&(state->fract->refresh));
	    connected = true;
	} else
	    connected = false;
// 	connect_to_method(perspective->toggled, this, 
// 			  &Fract_Rot::set_perspective);
// 	connect_to_signal(perspective->toggled, state->fract->refresh);
// 	connect_to_method(zoom_adj->value_changed, this, &Fract_Rot\::set_zoom);
// 	connect_to_signal(zoom_adj->value_changed, state->fract->refresh);
//	show();
}

void Fract_Rot::detach_signals() {
    if(connected) {
	rot_sig.disconnect();
	connected = false;
    }
}

void Fract_Rot::attach_signals(Signal0 *signal) {
    connected = true;
    rot_sig = connect_to_signal(rot->changed, *signal);
}

