#include "fract_rot_state.h"

Fract_Rot_State::Fract_Rot_State() {
    add_child(&rot);
}

void Fract_Rot_State::load(FILE * fp) {
    fscanf(fp, " %f %d ", &zoom_val, &perspective_on);
    rot.load(fp);
} 

void Fract_Rot_State::save(FILE * fp) {
    fprintf(fp, "%.5f %d\n", zoom_val, perspective_on);
    rot.save(fp);
}

void Fract_Rot_State::set_default() { 
    zoom_val = 1.0;
    perspective_on = true;
    rot.xpos = 0;
    rot.ypos = 0;
}
Fract_Rot * Fract_Rot_State::create_gui() {
    return view = new Fract_Rot(this); 
}

//	void Fract_Rot_State::show_dialog() { view = new Fract_Rot(this); }
// bool operator !=(State & other) {
//     return(zoom_val != other.zoom_val ||
// 	   perspective_on != other.perspective_on ||
// 	   view != other.view ||
// 	   rot != other.rot);
// }
double Fract_Rot_State::get_zoom_val() {
//	    assert(view);
    printf("view = %p\n", view);
    if(view == NULL)
	return zoom_val;
    else
	return(GTK_ADJUSTMENT(view->zoom_adj->gtkobject)->value);
}
