#ifndef FRACT_ROT_STATE_H
#define FRACT_ROT_STATE_H

#include "fract_rot.h"
#include "state.h"
#include "positioner.h"


class Fract_Rot_State : public ::State {
	
private:

public:

    double zoom_val;
    bool perspective_on;
    class Positioner::State rot;

    class fractal * fract;
    class Fract_Rot * view;

    Fract_Rot_State();
    void load(FILE * fp);
    void save(FILE * fp);
    void set_default();
    class Fract_Rot * create_gui();
//	void show_dialog() { view = new Fract_Rot(this); }
    double get_zoom_val();
};


#endif
