#ifndef FRACT_VIEW_STATE_H
#define FRACT_VIEW_STATE_H

#include "fract_view.h"
#include "positioner.h"

class Fract_View_State : public ::State {
	
private:

public:

    double min_zoom, max_zoom;
    double zoom_val;
    bool perspective_on;
    class Positioner::State rot;

    class fractal * fract;
    class Fract_View * view;
	
    Fract_View_State();
    void load(FILE * fp);
    void save(FILE * fp);
    void set_default();
    Fract_View * create_gui();
    double get_zoom_val();
};

#endif
