#include "g_list.h"

G_List & G_List::operator =(G_List l) {
    l->ref_count++;
    
}

G_List::G_List() {
    gobj = g_list_alloc();
    ref_count = 0;
}

G_List::G_List(GList *castitem) {
    gobj = castitem;
    ref_count = 0;
}

void free_1() {
    ref_count--;
    g_list_free_1(gobj);
    if(! ref_count > 0)
	delete this;		// is this bad?
}

G_List::~G_List() {
    g_list_free(gobj);
}

G_List *G_List::append(gpointer data) { 
    g_list_append(gobj,data);
}

G_List *G_List::prepend(gpointer data) { 
    GList * newlist = g_list_prepend(gobj,data);
    if(newlist == gobj) 
	return this;
    else
	return new G_List(newlist);
}

/*
  what about the case when you do something like this:

  G_List * l = new G_List;
  l = l->append((gpointer)"5");
 */

G_List * operator =(G_List * a, G_List *b) { // this would be nice
    b->ref_count++;
    if(--a->ref_count == 0)
	delete b;
    return(b);
}

G_List *G_List::insert(gpointer data, gint position) { 
    g_list_insert(gobj, data, position);
}

G_List *G_List::remove(gpointer data) { 
    
}

G_List *G_List::remove_link(G_List * link) { 
    
}

G_List *G_List::reverse() { 
    
}

G_List *G_List::nth(gint n) { 
    
}

G_List *G_List::find(gpointer data) { }

G_List *G_List::last() { }

G_List *G_List::first() { }

int G_List::length() { }

void G_List::foreach(GFunc func, gpointer user_data) { }

template <class T> 
void foreach(T *,void (T::*)(gpointer,gpointer), gpointer user_data) { }
