
#define YYSTYPE expr_ref

#include "eq_table.h"
#include "expr_parser.h"
#include "expr_tree.h"
#include <stdio.h>

extern char * yy_scan_string(const char *);
extern expr_ref tree_top;
extern int yyparse();

void main() {

    double p[4];

    int f;

    p[0] = 0;
    p[1] = 0;
    p[2] = 0;
    p[3] = 0; 

    yy_scan_string("q*q");

    yyparse();

    eq_table * tab = new eq_table(tree_top, 20, 20);
    
    tab->iter(p[0], p[1], p[2], p[3], f);
    
    printf("f = %d\n", f);

}
