/*
 *  main.cc
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#ifdef USE_THREADS
#include <pthread.h>
#include <semaphore.h>
#endif
#include "listwindow.h"

extern int yydebug;

int main(int argc, char *argv[])
{

//    yydebug = 1;

#ifdef USE_THREADS
    printf("XinitThreads\n");
    assert(XInitThreads());
#endif
    printf("ff\n");
    Gtk_Main gui(&argc, &argv);

    printf("ff\n");
    list_window win;
    win.show();
    printf("ff\n");

    if(argc > 1) {
	for(int i = 1 ; i <= argc ; i++) 
	    win.load_item(argv[i]);
    }
    printf("ff\n");

/*
    while(1) {
 	while(gtk_events_pending()) {
	    XLockDisplay(model->dpy);
// 	    sem_wait(&(model->x_mutex));
	    printf("GTK - mutex acquired\n");
 	    gui.iteration();
	    printf("GTK - releasing mutex\n");
	    XUnlockDisplay(model->dpy);
	    //    sem_post(&(model->x_mutex));
 	}
	if(gtk_events_pending())
	    gui.iteration();
	if(!model->gtk_req.isEmpty()) {
	    model->gtk_req.remove();
	    glXSwapBuffers(model->dpy,model->drawable);
	}
    }
*/
    gui.run();

    return 0;
} 





