#include "statelist.h"

StateList::StateList() {
    list = g_list_alloc();
    connect_to_method(append, this, &StateList::append_impl);
    connect_to_method(append, this, &StateList::remove_impl);
}

void StateList::append_impl(fractal_State *state) {
    list = g_list_append(list,(gpointer)state);
}

void StateList::remove_impl(fractal_State *state) {
    list = g_list_remove(list,(gpointer)state);
}

GList * StateList::get_list() {
    return list;
}
