/*
 *  Gtk_CoordBox_state.cc
 * 
 *  Fractal Generator
 * 
 *  Copyright (c) 1998 Brian Martin
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "Gtk_CoordBox_state.h"

Gtk_CoordBox_State::Gtk_CoordBox_State() {
    add_child(&x);
    add_child(&y);
    add_child(&z);
}

void Gtk_CoordBox_State::load(FILE * fp) {
    char buf[100];
    fscanf(fp, " %s %d ", buf, &constrained);
    label = strdup(buf);	// should probably free this at some point
    this->::State::load(fp);		// does this work?
    
}
void Gtk_CoordBox_State::save(FILE * fp) {
    fprintf(fp, "%s %d\n", label, constrained);
    ::State::save(fp);
}
// bool operator !=(State & other) {
//     return(x != other.x ||
// 	   y != other.y ||
// 	   z != other.z ||
// 	   constrained != other.constrained);
// }
bool Gtk_CoordBox_State::changed() {
    return(x.changed() || y.changed() || z.changed());
}

