// -*- c++ -*-

#ifndef _MENU_FACTORY_H_
#define _MENU_FACTORY_H_

#include "gtk--.h"

class MenuFactory : public Gtk_MenuFactory
{
public:
  MenuFactory(GtkMenuFactoryType);

  template <class T>
  Gtk_MenuItem* add_entry(char *path,
			  char *accelerator,
			  T *target_widget,
			  void (T::*target_method)(char*),
			  char *target_method_arg);
  			 
  Gtk_Menu* menubar_widget(void)
    {return new Gtk_Menu(GTK_MENU(gtkmenufactory->widget));}
  GtkMenuFactory * gtkobj() { return gtkmenufactory; }
//   Gtk_AcceleratorTable* accelerators(void)
//     { return new Gtk_AcceleratorTable(gtkmenufactory->table);}
  
};


#ifndef BROKEN_GPP
template <class T>
Gtk_MenuItem* MenuFactory::add_entry(char *path,
				     char *accelerator,
				     T *target_widget,
				     void (T::*target_method)(char*),
				     char *target_method_arg)
{
  static GtkMenuEntry entry = { NULL, NULL, NULL, NULL, NULL };
  Gtk_MenuItem *entry_widget;
  
  entry.path = path;
  entry.accelerator = accelerator;
  
  add_entries(&entry, 1);
  
  entry_widget = new Gtk_MenuItem((GtkMenuItem*)entry.widget);
  
  connect_to_method(entry_widget->activate,
	  target_widget, target_method, target_method_arg);
  
  return entry_widget;
  
}
#endif

#endif
