#ifndef FRACT_PARAMS_STATE_H
#define FRACT_PARAMS_STATE_H

#include "Gtk_CoordBox_state.h"
#include "Gtk_HEntryScale_state.h"
#include "fract_params.h"

class Fract_Params_State : public ::State {

 public:

    class Fract_Params * gui;
    class fractal * fract;

    class Gtk_CoordBox_State minval;
    class Gtk_CoordBox_State maxval;
    class Gtk_CoordBox_State size;
    class Gtk_CoordBox_State zoom;
    class Gtk_CoordBox_State pan;

    Gtk_HEntryScale_State w_fix;
    //	expr_ref expr;
    const char * expr_string;
    expr_ref expr_list;
    expr_ref expr_tree;
	
    bool bounding_box_visible;
    bool zoom_box_visible;
    bool q_is_c_initially;
    double initial_q_val[4];
    Gtk_HEntryScale_State bounding_res;

    void load(FILE * fp);
    void save(FILE * fp);
    void show_dialog();
	    
    expr_ref set_expr(FILE *);
    expr_ref set_expr(const char *);
	
    void set_default();

    void grab();
    void apply();
    bool changed();

    Fract_Params_State();
};

#endif
