#ifndef FRACT_STRUCTS_H
#define FRACT_STRUCTS_H

#include "list.h"
#include "octree.h"

struct fcoord {

    float color[4];		// the order of these first three elements
    float norm[3];		// is (no longer) important
    float pos[3];    

    DList<struct fpoly *> *polys;
    bool normalized;

    fcoord() {
/* 	color[0] = 0.0; */
/* 	color[1] = 0.0; */
/* 	color[2] = 0.0; */
/* 	color[3] = 1.0; */
	polys = 0;
	normalized = false;
    }
    
    void dumpPoint() {
	printf("point is %.2f %.2f %.2f\n", pos[0], pos[1], pos[2]);
    }

    void dumpColor() {
	printf("color is %.2f %.2f %.2f\n", color[0], color[1], color[2]);
    }

    void dumpNormal() {
	printf("%.2f %.2f %.2f\n", norm[0], norm[1], norm[2]);
    }

    void multNormal(float coef) {
	norm[0] *= coef;
	norm[1] *= coef;
	norm[2] *= coef;
    }

//    void normalizeNormal(char*);
};

struct fpoly {			// these are triangles
    
    struct fcoord * vert[3];		// vertex indices
    struct fpoly * next, *prev;
    bool deleted;
    class tree_params * params;
    float norm[3];		// strict cross product of verticies
    fpoly(): next(0), prev(0), deleted(false) {}
    void clear_points();

    ~fpoly() { 
	if(deleted) {
//	    printf("fuck fuck fuck!!!\n");
	    printf("delete called twice\n");
	    exit(-14);
	} else {
	    deleted = true; 
	}	
    }
//     ~fpoly() {
// 	printf(fpoly()\n");
// 	if(next)
// 	    next->prev = prev;
// 	if(prev)
// 	    prev->next = next;
//     }

};




#endif
