#ifndef FRACTAL_STATE_H
#define FRACTAL_STATE_H

#include "state.h"
#include "fractal.h"
#include "view_window_state.h"
#include "fract_params_state.h"

class view_window_State;

class fractal_State : public ::State {
    
private:
    
public:

    fractal *fract;
    char * filename;
    char * name;		// name to display in lists
	
    class Fract_Params_State gui;
    class view_window_State lw;

    fractal_State();
    void save();
    void load(char *);
    void set_name_from_filename(char *);
    void set_default();
    void show_fractal();
};

#endif
