#ifndef G_LIST_H
#define G_LIST_H

class G_List {

private:
    
    GList gobj;
    int ref_count;
    
public:
    
    G_List();
    ~G_List();
    void free_1();
    G_List *append(gpointer data);
    G_List *prepend(gpointer data);
    G_List *insert(gpointer data, gint position);
    G_List *remove(gpointer data);
    G_List *remove_link(G_List * link);
    G_List *reverse();
    G_List *nth(gint n);
    G_List *find(gpointer data);
    G_List *last();
    G_List *first();
    G_List *length();
    G_List *foreach(GFunc func, gpointer user_data);
    template <class T> 
    G_List *foreach(T *,void (T::*)(gpointer,gpointer), gpointer user_data);
}

#endif
