#include <libquat.h>
#include <stdio.h>

extern char * yy_scan_string(const char *);
extern expr_ref tree_top;
extern int yyparse();

void main() {

    double p[4];

    int f;

    p[0] = -1.014486;
    p[1] = -0.145833;
    p[2] = 0;
    p[3] = 0; 

    if(argc > 1)
	yy_scan_string(argv[1]);
    else 
	yy_scan_string("q*q+[-1.1 -0.2145833 0 0]");

    yyparse();

    eq_table * tab = new eq_table(tree_top, 400, 20);
    
    tab->iter(p[0], p[1], p[2], p[3], f);
    
    printf("iters = %d\n", f);

}
