/* Quat - A 3D fractal generation program 
   Copyright (C) 1997 Dirk Meyer 
   (email: dirk.meyer@studbox.uni-stuttgart.de) 

   This program is free software; you can redistribute it and/or 
   modify it under the terms of the GNU General Public License 
   as published by the Free Software Foundation; either version 2 
   of the License, or (at your option) any later version. 

   This program is distributed in the hope that it will be useful, 
   but WITHOUT ANY WARRANTY; without even the implied warranty of 
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
   GNU General Public License for more details. 

   You should have received a copy of the GNU General Public License 
   along with this program; if not, write to the Free Software 
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */

#include <stdio.h>
#include <math.h>

typedef double point[4];

int iternorm(point xstart, point c, double bailout, int maxiter)
{
   static point x, ox;
   static point xs;   /* x to square */   
   static double xss; /* sum of components of xs */
   static double diff[3][3], odiff[3][3]; 
   /* differentiations of 1st index to 2nd index */
   /* could be called Jacobi-matrix */
   static double tmp = 0;
   static int iter, i, j;
   
   printf("fuck\n");
   
   xss = 0; iter = 0;
     for (i=0; i<4; i++) 
   {
      ox[i] = xstart[i];
      xs[i] = ox[i]*ox[i];
      xss += xs[i];
   }
     printf("%d %.2f %.2f %.2f %.2f\n", iter, xstart[0], xstart[1], xstart[2], xstart[3]);
   while ( xss<bailout && iter<maxiter )
   {
      /* usual quaternion z^2-c iteration */
      tmp = ox[0] * ox[1]; x[1] = tmp + tmp - c[1];
      tmp = ox[0] * ox[2]; x[2] = tmp + tmp - c[2];
      tmp = ox[0] * ox[3]; x[3] = tmp + tmp - c[3];
      x[0] = xs[0] + xs[0] -xss - c[0]; 
      
      xss = 0;
      for (i=0; i<4; i++)
      {
         xs[i] = x[i]*x[i];
         xss += xs[i];
         ox[i] = x[i];
      }
      printf("%d %.2f %.2f %.2f %.2f\n", iter, ox[0], ox[1], ox[2], ox[3]);

      iter++;
   }
   xss = sqrt(x[0]*x[0] + x[1]*x[1] + x[2]*x[2] + x[3]*x[3]);
   return(iter);
}


int main() {
    
    point p;
    point c;

    printf("input point\n");
//    scanf("%lf %lf %lf %lf\n", &p[0], &p[1], &p[2], &p[3]);
  
    p[0] = 0;
    p[1] = 0;
    p[2] = 0;
    p[3] = 0;
  
    c[0] = 1;
    c[1] = 1;
    c[2] = 1;
    c[3] = 1;

    iternorm(p, c, 20, 20);

}

   

